# -*- coding: utf-8 -*-

import sys,os,os.path
from qt import *
from frmmain import frmMain
from viewbox import ViewBox
from palettebox import PaletteBox
from palette import Palette
from graphics import Graphic


class frmMain_impl(frmMain):

    def __init__(self,parent = None,name = None,modal = 0,fl = 0):
        frmMain.__init__(self,parent,name,modal,fl)

	# View Frame
	self.ViewBox=ViewBox(self.fraView,"ViewBox")
	self.ViewBox.setGeometry(QRect(10,10,self.fraView.size().width()-20,self.fraView.size().height()-20))
	#self.ViewBox.setSizePolicy(QSizePolicy(QSizePolicy.Expanding,QSizePolicy.Expanding,1,1,self.ViewBox.sizePolicy().hasHeightForWidth()))
	fraViewLayout = QGridLayout(self.fraView,1,1,6,6,"fraViewLayout")
	fraViewLayout.addWidget(self.ViewBox,0,0)
	
	self.tabTool.setMinimumSize(QSize(200,330))
	
	# Palette Tab
	tabPaletteLayout=QVBoxLayout(self.tabPalette,6,6,"tabPaletteLayout")
	
	self.PaletteBox=PaletteBox(self.tabPalette,"PaletteBox")
	self.PaletteBox.setGeometry(QRect(8,8,self.tabPalette.size().width()-20,self.tabPalette.size().height()-20))
	self.PaletteBox.setMinimumSize(QSize(180,160))
	self.PaletteBox.setAllowSelect(False)
	tabPaletteLayout.addWidget(self.PaletteBox)
	
	self.listPalette=QListBox(self.tabPalette,"listPalette")
	self.listPalette.setMinimumSize(QSize(180,120))
	tabPaletteLayout.addWidget(self.listPalette)

	# Info Tab
	self.chkBoxJunction.setUpdatesEnabled(False)
	self.chkBoxIntPal.setUpdatesEnabled(False)
	self.chkBoxFuncColor.setUpdatesEnabled(False)
	self.chkBoxFillBg.setUpdatesEnabled(False)
	self.chkBoxNoCompress.setUpdatesEnabled(False)

	# Bottom frame
	self.progBarBottom.hide()

	# Signals
	self.connect(self.listLBX,SIGNAL("currentChanged(QListBoxItem*)"),self.listLBX_currentChanged)
	self.connect(self.listPalette,SIGNAL("currentChanged(QListBoxItem*)"),self.listPalette_currentChanged)
	self.connect(self.spinBoxCurFrame,SIGNAL("valueChanged(int)"),self.spinBoxCurFrame_currentChanged)

	# Non gui init
	self.prepare()

    def prepare(self):
	self.__pal=False
	self.__gfx=False
	self.__palname=False
	self.__gfxname=False
	self.__paldir='pal'
	self.__lbxdir='lbx'
	self.populateList(self.getDirList(self.__paldir),self.listPalette)
	self.populateList(self.getDirList(self.__lbxdir),self.listLBX)

    def populateList(self,list,listwidget):
	listwidget.clear()
	for item in list:
	    listwidget.insertItem(item)
	listwidget.setCurrentItem(0)

    def getDirList(self,directory):
	dirlist=os.listdir(directory)
	reslist=[]
	for item in dirlist:
	    if (os.path.isfile(directory+'/'+item)):
		reslist.append(item)
	return reslist

    def listLBX_currentChanged(self,listitem):
	self.__gfxname=self.__lbxdir+'/'+str(listitem.text())
	self.__gfx=Graphic(self.__gfxname)
	#self.__
	self.updateView()
	
    def updateView(self):
	if (self.__gfx==False):
	    return
	self.ViewBox.setPalette(self.__pal)
	self.ViewBox.setGraphic(self.__gfx)

	# Check if we have valid graphic
	if (self.__gfx.countframes()!=False):
	    # If we encountered internal palette
	    if (self.__gfx.getflags()['ipal']==1):
		intpal=Palette(self.__gfx.getipal())
		self.ViewBox.setPalette(intpal)
		self.PaletteBox.setPalette(intpal.getallcolors())
		# Update PaletteBox
		self.PaletteBox.update()
	    else:
		self.PaletteBox.setPalette(self.__pal.getallcolors())
		# Update PaletteBox
		self.PaletteBox.update()
		

	    # Reenable disabled 
	    self.spinBoxCurFrame.setEnabled(True)
	    self.lblSizeInfo.setEnabled(True)
	    self.lblFrameInfo.setEnabled(True)
	    self.lblDelayInfo.setEnabled(True)

	    # Update info
	    gw,gh=self.__gfx.getwh()
	    sizetext=str(gw)+' x '+str(gh)
	    self.lblSizeInfo.setText(sizetext)
	    frames=str(self.__gfx.countframes())
	    self.lblFrameInfo.setText(frames)
	    delay=str(self.__gfx.getdelay())
	    self.lblDelayInfo.setText(delay)
	    
	    # Update current frame spinbox
	    self.spinBoxCurFrame.setRange(1,self.__gfx.countframes())

	    # Update flags info
	    flags=self.__gfx.getflags()
	    if (flags['junc']==0):
		self.chkBoxJunction.setChecked(False)
	    else:
		self.chkBoxJunction.setChecked(True)
	    if (flags['ipal']==0):
		self.chkBoxIntPal.setChecked(False)
	    else:
		self.chkBoxIntPal.setChecked(True)
	    if (flags['func']==0):
		self.chkBoxFuncColor.setChecked(False)
	    else:
		self.chkBoxFuncColor.setChecked(True)
	    if (flags['fill']==0):
		self.chkBoxFillBg.setChecked(False)
	    else:
		self.chkBoxFillBg.setChecked(True)
	    if (flags['nocomp']==0):
		self.chkBoxNoCompress.setChecked(False)
	    else:
		self.chkBoxNoCompress.setChecked(True)
	else:
	    # FIXME (do something else here!)
	    self.spinBoxCurFrame.setValue(0)
	    self.spinBoxCurFrame.setEnabled(False)
	    self.lblSizeInfo.setEnabled(False)
	    self.lblFrameInfo.setEnabled(False)
	    self.lblDelayInfo.setEnabled(False)
	    print "Not valid graphic file!"

	# Update ViewBox
	if (self.spinBoxCurFrame.value()==0):
	    self.ViewBox.setCurrentFrameNum(0)
	else:
	    self.ViewBox.setCurrentFrameNum(self.spinBoxCurFrame.value()-1)
	self.ViewBox.update()
#	self.ViewBox.repaint()
	

    def listPalette_currentChanged(self,listitem):
	self.__palname=self.__paldir+'/'+str(listitem.text())
	self.__pal=Palette(self.__palname)
	self.PaletteBox.setPalette(self.__pal.getallcolors())
	self.PaletteBox.update()
	self.updateView()

    def spinBoxCurFrame_currentChanged(self,value):
	self.updateView()

if __name__ == "__main__":
    a = QApplication(sys.argv)
    QObject.connect(a,SIGNAL("lastWindowClosed()"),a,SLOT("quit()"))
    w = frmMain_impl()
    a.setMainWidget(w)
    w.show()
    a.exec_loop()
